local bgcolor = {207/255,10/255,247/255}
local ActivateFunc = function(self)
    if self.dag:IsPlaying() then self.dag:Stop() end
    if self.rag:IsPlaying() then self.rag:Stop() end
    if self:GetAlpha() == 1 then return end
    self.aag:Play()
end
local DeactivateFunc = function(self)
    if self.aag:IsPlaying() then self.aag:Stop() end
    if self.rag:IsPlaying() then self.rag:Stop() end
    if self:GetAlpha() == 0 then return end
    self.dag:Play()
end
    local OnFinishedScript = function(self)
        local f = self:GetParent()
        f:dagfunc()
        f:Activate()
        f.dagfunc = nil
        self:SetScript("OnFinished", nil)
    end
local ReappearFunc = function(self, func, arg)
    if self.aag:IsPlaying() then self.aag:Stop() end
    if self.dag:IsPlaying() then self.dag:Stop() end
    self.ragfunc = func
    self.ragfuncarg = arg
    self.rag:Play()
end


local SetColorFunc = function(self,r,g,b)
    self.t:SetVertexColor(r,g,b)
end

function NugComboBar.SetMaxPoints(self, n, special)
    if NugComboBar.MAX_POINTS == n then return end
    --local shiftlen = NugComboBar.MAX_POINTS - n
    NugComboBar.MAX_POINTS = n

    for _, point in pairs(self.point) do
        point:SetAlpha(0)
        point:Hide()
        point:ClearAllPoints()
    end

    local prevt
    for i=1,NugComboBar.MAX_POINTS do
        local point = self.p[i]
        point:Show()
        point:SetPoint("CENTER",prevt or self, prevt and "CENTER" or "LEFT", prevt and 22 or 44, 0)
        prevt = point

        point:SetColor(unpack(NugComboBarDB.colors[i])) --+color_offset
    end
end

NugComboBar.Create = function(self)
    local MAX_POINTS = 6
    self:SetFrameStrata("MEDIUM")
    local w = 174
    self:SetWidth(w)
    self:SetHeight(64)

    self.point = {}
    self.p = self.point
    -- self.point_map = mappings[6]
    -- self.p = setmetatable({}, { __index = function(t,k)
        -- return self.point[self.point_map[k]]
    -- end})

    
    -- local bgt = self:CreateTexture(nil,"BACKGROUND")
    --bgt:SetTexture("Interface\\Addons\\NugComboBarStriped\\tex\\ncbs_line")
    -- bgt:SetTexCoord(0, w/256, 0, 1)
    -- bgt:SetAllPoints(self)
    -- self.bgt = bgt
    --bgt:SetVertexColor(unpack(bgcolor))

    local offsetX = 44
    local offsetY = 0
    local color_offset = 5 - MAX_POINTS
    for i=1,MAX_POINTS do
        local size = 64
        local tex = [[Interface\Addons\NugComboBarStriped\tex\ncbs_point]]
        local mul = 1.5
        local glowAlpha = 0.6
        local f = CreateFrame("Frame","NugComboBarPoint"..i,self)
        f:SetHeight(size); f:SetWidth(size);
        local t = f:CreateTexture(nil,"ARTWORK")
        t:SetTexture(tex)
        t:SetAllPoints(f)
        f.t = t
        
        f:SetPoint("CENTER",prev or self, prev and "CENTER" or "LEFT",offsetX,offsetY)

        offsetX = 22
        offsetY = 0
        
        f:SetAlpha(0)
        
--~         local g2 = f:CreateTexture(nil,"ARTWORK",nil,2)
--~         g2:SetHeight(size*mul); g2:SetWidth(size*mul);
--~         g2:SetTexture[[Interface\Addons\NugComboBarStriped\tex\ncbs_point]]
--~         g2:SetPoint("CENTER",f,"CENTER",0,0)
--~         f.g2 = g2
--~         g2:SetAlpha(0)
        
--~         local g2aag = g2:CreateAnimationGroup()
--~         local g2a = g2aag:CreateAnimation("Alpha")
--~         g2a:SetChange(1)
--~         g2a:SetDuration(0.3)
--~         g2a:SetOrder(1)
--~         local g2s1 = g2aag:CreateAnimation("Scale")
--~         g2s1:SetScale(1,1.2)
--~         g2s1:SetDuration(0.3)
--~         g2s1:SetOrigin("BOTTOMLEFT",0,0)
--~         g2s1:SetOrder(1)
--~         local g2d = g2aag:CreateAnimation("Alpha")
--~         g2d:SetChange(-1)
--~         g2d:SetDuration(0.7)
--~         g2d:SetOrder(2)
--~         local g2s2 = g2aag:CreateAnimation("Scale")
--~         g2s2:SetScale(1.25,0.66)
--~         g2s2:SetDuration(0.3)
--~         g2s2:SetOrder(2)
--~         f.glow2 = g2aag
        
        f.SetPreset = function() end
        f.SetColor = SetColorFunc
        -- f:SetColor(unpack(NugComboBarDB.colors[i+color_offset]))
        
        prev = f

        local aag = f:CreateAnimationGroup()
        f.aag = aag
        local a1 = aag:CreateAnimation("Translation")
        --a1:SetOffset(18,48)     --diagonal
        a1:SetOffset(30,0)
        a1:SetDuration(0)
        a1:SetOrder(1)
        local a2 = aag:CreateAnimation("Translation")
        --a2:SetOffset(-18,-48)    --diagonal
        a2:SetOffset(-30,0)
        a2:SetDuration(0.4)
        a2:SetOrder(2)
        local a3 = aag:CreateAnimation("Alpha")
        a3:SetChange(1)
        a3:SetDuration(0.4)
        a3:SetOrder(2)
        aag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(1)
        end)


        local dag = f:CreateAnimationGroup()
        f.dag = dag
        local d1 = dag:CreateAnimation("Alpha")
        d1:SetChange(-1)
        d1:SetDuration(0.7)
        d1:SetOrder(1)
        dag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(0)
        end)

        local rag = f:CreateAnimationGroup()
        f.rag = rag
        local r1 = rag:CreateAnimation("Translation")
        r1:SetOffset(6,16)
        r1:SetDuration(0.20)
        r1:SetOrder(1)
        r1:SetScript("OnFinished", function(self)
            local p = self:GetParent():GetParent()
            p:ragfunc(p.ragfuncarg)
        end)
        local r2 = rag:CreateAnimation("Translation")
        r2:SetOffset(-6,-16)
        r2:SetDuration(0.40)
        r2:SetOrder(2)
        rag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(1)
        end)
        
        
        f.Activate = ActivateFunc
        f.Deactivate = DeactivateFunc
        f.Reappear = ReappearFunc
        self.point[i] = f
    end    
    return self
end